import os
import sys
import optparse
import numpy as np

# we need to import some python modules from the $SUMO_HOME/tools directory
if 'SUMO_HOME' in os.environ:
    tools = os.path.join(os.environ['SUMO_HOME'], 'tools')
    sys.path.append(tools)
else:
    sys.exit("please declare environment variable 'SUMO_HOME'")


from sumolib import checkBinary  # Checks for the binary in environ vars
import traci


def get_options():
    opt_parser = optparse.OptionParser()
    opt_parser.add_option("--nogui", action="store_true",
                         default=False, help="run the commandline version of sumo")
    options, args = opt_parser.parse_args()
    return options

t = np.arange(5,10000, 10)
vehID = np.arange(5,10000, 10)

# contains TraCI control loop
def run():
    step = 0
    while traci.simulation.getMinExpectedNumber() > 0:
        traci.simulationStep()
    #    print(step)
    #while step < 10000:
     #   traci.simulationStep() # advance the simulation one time step
     #   for i,j in zip(t, vehID):
        #    for j in vehID:
      #      if step == i:
       #         traci.vehicle.add(str(j), 'r1', typeID='TV',  departLane='random', departSpeed='max')
        #        #traci.vehicle.add(str(j), 'r1', typeID='TV', depart=None, departLane='free', departPos='base')

        step += 1

    traci.close()
    sys.stdout.flush()


# main entry point
if __name__ == "__main__":
    options = get_options()

    # check binary
    if options.nogui:
        sumoBinary = checkBinary('sumo')
    else:
        sumoBinary = checkBinary('sumo-gui')

    # traci starts sumo as a subprocess and then this script connects and runs
    traci.start([sumoBinary, "-c", "config3.sumocfg",
                             "--tripinfo-output", "0CAV0AV100TV_5Ramp_V3.xml"])
    run()